CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
   
OBJ
  tch:           "Touch"                                 ' touchscreen driver

VAR long stringcounter
    long arrayfile
    long arraycounter
    long arrayindex
    long objectcounter

PUB Main | touchtest  ' debug value
  tch.BeginProgram                                          
  ArrayTest
  tch.SetWarmBoot                                           ' clears screen, sets a warm boot and reboots

PUB ArrayTest | n,myarray 
   tch.Clearscreen(%00000000_00000000)                  ' clear the screen
   tch.ClearRam
   tch.Text(string("Array test"))
   myarray := tch.ArrayDim(10)             ' dim an array, myarray stores the filenumber
   tch.arraywrite(myarray,0,$12345678)                        ' store data to the array
   tch.arraywrite(myarray,1,$AABBCCDD)
   tch.hex(tch.arrayread(myarray,1),8)                  ' read back and display
   tch.hex(tch.arrayread(myarray,0),8)                  ' read back
   ArrayTwoDimensions
   repeat

   ' demo program for GUIspin
   CreateArrays
   Form1DesignerVB
   
{
PUB ArrayTwoDimensions | twodim,twodimrows,twodimcols,n
    twodimrows := 20
    twodimcols := 80
    twodim := ArrayDimTwoDimensions(twodimrows,twodimcols)  ' get file number
    ArrayTDWrite(twodim,5,4,twodimcols,$34567890)
    n := ArrayTDRead(twodim,5,4,twodimcols)
    tch.hex(n,8)


PUB ArrayDimTwoDimensions(rows,cols)                          ' dim a two dimensional array
    result := tch.ArrayDim(rows*cols)                         ' returns filenumber

PUB ArrayTDWrite(f,row,col,sizecol,n)                   ' filenumber, row, column, number of columns, data
    tch.arraywrite(f,row*sizecol+col,n)                   ' store

PUB ArrayTDRead(f,row,col,sizecol)
    result := tch.arrayread(f,row*sizecol+col)
}
' create objects for textbox, buttons etc. Strings referenced by number in an array. Common variable stringcounter
' List of links to objects at the beginning of the array (256 entries). This is a jump table.
' then within each object, values and also links to strings. If add a string then increment the stringpointer
PUB CreateArrays
  tch.stringdim(100)                                    ' space for strings
  stringcounter := 16                                   ' first 16 strings reserved for general purpose strings
  arrayfile := tch.arraydim(2000)                       ' space for longs
  arraycounter := 256                                   ' first 256 longs reserved for object addresses
  arrayindex := 0                                       ' index of objects

PUB Form1DesignerVB                                     ' code from form1designervb file translated to spin
  NewButton(tch.stringstore(1,string("Button1")))             'Me.Button1 = New System.Windows.Forms.Button
  ButtonLocationSet(tch.stringstore(1,string("Button1")),68,37)  'Me.Button1.Location = New System.Drawing.Point(68, 37)

PUB NewButton(s)
   ' reserve 32 bytes in the array, increment the arraycounter, store the name and increment string counter
   tch.stringcopy(stringcounter,s)                      ' copy name to new location
   tch.arraywrite(arrayfile,arrayindex,arraycounter)    ' store the index location
   arrayindex +=1                                       ' add 1 to object index
   tch.arraywrite(arrayfile,arraycounter,stringcounter) ' store location of the name string
   stringcounter +=1                                    ' increment global stringcounter
   arraycounter +=32                                    ' 32 longs for a button


PUB NewTextbox(s)
   ' reserve 32 bytes in the array

PUB ButtonSizeSet(s,x,y)                           ' pass name of the button, stores x and y

PUB ButtonTextSet(s,s2)                 ' pass name, stores the text on the button

PUB ButtonLocationSet(s,x,y) | n,i                       ' pass name, stores the location
   n := Getlocation(s)                                  ' find the name
   if n <> -1                                           ' found a match
     i := tch.arrayread(arrayfile,n)                    ' get the location of the object
     tch.arraywrite(filelocation,i+1,x)
     tch.arraywrite(filelocation,i+2,y) 

PUB ButtonSizeGetX(s)                           ' pass name, returns x value

PUB ButtonSizeGetY(s)                           ' pass name returns y value

PUB ButtonTextGet(s)                            ' pass name, returns name in stringarray(1)

PUB ButtonLocationGetX(s)

PUB ButtonLocationGetY(stringptr)


PUB GetLocation(s) | n                              ' pass name eg Button1, returns location in array
    ' match with the string list starting at 16, if matches check the lookuptable and get the location
    ' if no match then returns -1
    result := -1       
    repeat n from 16 to 256
      if tch.stringcompare(n,s) == true
        result := n
        quit

