CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
   
OBJ
  tch:           "Touch"                                 ' touchscreen driver

PUB Main | touchtest  ' debug value
  tch.BeginProgram
  Calculator
  tch.SetWarmBoot                                           ' clears screen, sets a warm boot and reboots

PUB Calculator | xval,yval,address,ascii,operand,font,a,b,answer
    tch.Clearscreen(%00000000_00000000)                 ' so something happens immediately
    tch.ClearRam
    tch.SDBMPtoRam(string("calcpic.bmp"))                ' file 2
    tch.DrawBMPRam(2,0,0)                               ' draw the picture    
    font := tch.Loadfont(string("DSdig.ifn"))           ' file 3 in the ram disk, use this number when printing fonts
    tch.stringdim(10)                                   ' file 4is strings group, create some string space
    tch.stringclear(0)                                  ' use string 0
    tch.SelectSPIGroup                                   ' talk to the spi touchscreen  
    repeat
      yval := tch.TouchYPercent                           ' decode yval 0-100%               
      xval := tch.TouchXPercent                           ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)                    ' valid keypress
        tch.SelectMemGroup                              ' disconnect spi and talk to display
        'tch.hex(xval,2)                                 ' debugging
        address :=1 ' button doesn't do anything = default
        case (yval*32)/10                                    ' convert 0-100 to 0-320 as easier to work with pixels off the picture
          60..101: address :=0                               ' row of a 4x6 matrix
          104..140: address :=4
          146..183: address :=8
          187..222: address :=12
          228..265: address :=16
          271..307: address :=20
        case (xval*24)/10                                   ' column convert percent to 0-239
          0..66: address += 0
          67..119: address +=1
          120..172: address +=2
          173..239: address +=3
        ascii := lookupz(address: "X","Q","Q","Q","C",8,"/","*","7","8","9","-","4","5","6","+","1","2","3","=","0","0",".","=")
        case ascii
          "X"             : return                                              ' close the calculator
          "C"             : tch.stringclear(0)                                  ' clear the current string
                            CalcClear
          "0".."9"        : tch.StringAddChar(0,ascii) ' build the string
                            CalcClear
                            tch.StringPrint(font,0)                             ' print string
          "+","-","*","/" : tch.StringCopy(1,0)                                 ' copy string 0 to string 1 
                            tch.StringAddChar(0,ascii) ' display these too so can see typed something
                            CalcClear
                            tch.StringPrint(font,0)                             ' print string
                            tch.StringClear(0)                                  ' clear working string
                            operand := ascii
          "=" :             a := tch.StringVal(1)                               ' second value
                            b := tch.StringVal(0)                               ' first value
                            case operand
                                  "+" : answer := a + b                         ' add
                                  "-" : answer := a - b                         ' subtract
                                  "*" : answer := a * b                         ' multiply
                                  "/" : answer := a / b                         ' integer division
                            tch.StringStr(2,answer)                             ' store answer to string 2
                            CalcClear                                            ' clear the display ready to print the answer
                            tch.StringPrint(font,2)                             ' print the answer
        tch.SelectSPIGroup                                              ' restart the spi group if display something
        tch.pause1ms(250)' only display once so delay half a second to "debounce"

PUB CalcClear
     tch.ClearRectangle(25,21,220,48,tch.GetBackFontColor) ' clear an area the same color as the font background   
     tch.SetCursor(25,15)